SystemOrganization addCategory: #RelatedLinks!

Object subclass: #RLPropertyObject
	instanceVariableNames: 'name properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RelatedLinks'!

RLPropertyObject subclass: #RLFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RelatedLinks'!

!RLFormat class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 12:47'!
banner
	^self
		name: '468 x 60 Banner'
		width: 468
		height: 60
		format: '468x60_rc'! !

!RLFormat class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 12:50'!
defaultInstances
	^Array
		with: self leaderboard
		with: self banner
		with: self mediumRectangle
		with: self smallRectangle! !

!RLFormat class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 12:46'!
leaderboard
	^self
		name: '728 x 90 Leaderboard'
		width: 728
		height: 90
		format: '728x90_rc'! !

!RLFormat class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 12:48'!
mediumRectangle
	^self
		name: '300 x 250 Medium Rectangle'
		width: 300
		height: 250
		format: '300x250_rc'! !

!RLFormat class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 12:45'!
name: aNameString width: aWidthInteger height: aHeightInteger format: aFormatString
	^self new
		name: aNameString;
		width: aWidthInteger;
		height: aHeightInteger;
		format: aFormatString;
		yourself! !

!RLFormat class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 12:48'!
smallRectangle
	^self
		name: '180 x 150 Small Rectangle'
		width: 180
		height: 150
		format: '180x150_rc'! !

!RLFormat methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:43'!
format: aString
	self propertyAt: 'format' put: aString! !

!RLFormat methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:42'!
height: anInteger
	self propertyAt: 'height' put: anInteger! !

!RLFormat methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:42'!
width: anInteger
	self propertyAt: 'width' put: anInteger! !

!RLPropertyObject methodsFor: 'comparing' stamp: 'pmm 5/29/2006 20:02'!
= other
	^(other isKindOf: RLPropertyObject)
		and: [ other name = self name ]! !

!RLPropertyObject methodsFor: 'accessing' stamp: 'pmm 5/29/2006 20:01'!
hash
	^self name hash! !

!RLPropertyObject methodsFor: 'initialize-release' stamp: 'pmm 5/29/2006 12:52'!
initialize
	super initialize.
	self properties: Dictionary new! !

!RLPropertyObject methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:51'!
name
	^name! !

!RLPropertyObject methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:51'!
name: anObject
	name := anObject! !

!RLPropertyObject methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:51'!
properties
	^properties! !

!RLPropertyObject methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:51'!
properties: aDictionary 
	properties := aDictionary! !

!RLPropertyObject methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:51'!
propertyAt: aKey put: anObject
	self properties at: aKey put: anObject! !

RLPropertyObject subclass: #RLStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RelatedLinks'!

!RLStyle class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 16:26'!
darkBlue
	^self 
		name: 'Dark Blue'
		line: '000000'
		link: 'ffffff'
		backgournd: '3366cc'
		text: 'ffffff'
		source: 'dddddd'
		header: '95b8ff'
		footer: '95b8ff'! !

!RLStyle class methodsFor: 'accessing' stamp: 'pmm 5/29/2006 20:12'!
defaultInstances
	^OrderedCollection new
		add: self lightBlue;
		add: self darkBlue;
		add: self white;
		add: self yellow;
		add: self grey;
		add: self pink;
		add: self green;
		yourself! !

!RLStyle class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 16:33'!
green
	^self 
		name: 'Green'
		line: '000000'
		link: '336633'
		backgournd: 'ffffff'
		text: '000000'
		source: '999999'
		header: 'BAF0BA'
		footer: 'BAF0BA'! !

!RLStyle class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 16:30'!
grey
	^self 
		name: 'Grey'
		line: 'cccccc'
		link: '0000ee'
		backgournd: 'ffffff'
		text: '000000'
		source: '6f6f6f'
		header: 'eeeeee'
		footer: 'eeeeee'! !

!RLStyle class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 16:25'!
lightBlue
	^self 
		name: 'Light Blue'
		line: '336699'
		link: '0000ee'
		backgournd: 'ffffff'
		text: '000000'
		source: '6f6f6f'
		header: 'c6ddf4'
		footer: 'eeeeee'! !

!RLStyle class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 12:58'!
name: aNameString line: aLineColorString link: aLinkColorString backgournd: aBackgroundColorString text: aTextColorString source: aSourceColorString header: aHeaderColorString footer: aFooterColorString
	^self new
		name: aNameString;
		colorLine: aLineColorString;
		colorLink: aLinkColorString;
		colorBackground: aBackgroundColorString;
		colorText: aTextColorString;
		colorSource: aSourceColorString;
		colorHeader: aHeaderColorString;
		colorFooter: aFooterColorString;
		yourself! !

!RLStyle class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 16:31'!
pink
	^self 
		name: 'Pink'
		line: '990000'
		link: '990000'
		backgournd: 'ffffff'
		text: '000000'
		source: '6f6f6f'
		header: 'ffe6e6'
		footer: 'ffe6e6'! !

!RLStyle class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 16:28'!
white
	^self 
		name: 'White'
		line: 'cccccc'
		link: '333333'
		backgournd: 'ffffff'
		text: '000000'
		source: '6f6f6f'
		header: 'ffffff'
		footer: 'ffffff'! !

!RLStyle class methodsFor: 'instance creation' stamp: 'pmm 5/29/2006 16:30'!
yellow
	^self 
		name: 'Yellow'
		line: 'ffcc00'
		link: 'cc6600'
		backgournd: 'ffffff'
		text: '000000'
		source: '6f6f6f'
		header: 'f4eec6'
		footer: 'f4eec6'! !

!RLStyle methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:53'!
colorBackground: aString
	self propertyAt: 'color_bg' put: aString! !

!RLStyle methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:55'!
colorFooter: aString
	self propertyAt: 'color_footer' put: aString! !

!RLStyle methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:54'!
colorHeader: aString
	self propertyAt: 'color_header' put: aString! !

!RLStyle methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:53'!
colorLine: aString
	self propertyAt: 'color_line' put: aString! !

!RLStyle methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:53'!
colorLink: aString
	self propertyAt: 'color_link' put: aString! !

!RLStyle methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:54'!
colorSource: aString
	self propertyAt: 'color_source' put: aString! !

!RLStyle methodsFor: 'accessing' stamp: 'pmm 5/29/2006 12:54'!
colorText: aString
	self propertyAt: 'color_text' put: aString! !

!MAVisitor methodsFor: '*RelatedLinks' stamp: 'pmm 6/1/2006 19:12'!
visitPropertyDescription: aDescription
	self visitElementDescription: aDescription! !

PRBoxWidget subclass: #RLWidget
	instanceVariableNames: 'format type colors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RelatedLinks'!

!RLWidget class methodsFor: 'accessing-description' stamp: 'pmm 6/1/2006 19:59'!
descriptionColors
	^(MASingleOptionDescription selector: #colors label: 'Colors' priority: 1200)		
		options: RLStyle defaultInstances;
		reference: RLPropertyDescription new;
		beRequired;
		yourself! !

!RLWidget class methodsFor: 'accessing-description' stamp: 'pmm 6/1/2006 19:59'!
descriptionFormat
	^(MASingleOptionDescription selector: #format label: 'Format' priority: 1000)		
		options: RLFormat defaultInstances;
		reference: RLPropertyDescription new;
		beRequired;
		yourself! !

!RLWidget class methodsFor: 'accessing-description' stamp: 'pmm 8/26/2006 18:20'!
descriptionType
	^(MAMultipleOptionDescription selector: #type label: 'Type' priority: 1100)		
		options: self types;
		default: self types;
		componentClass: MAListCompositonComponent;
		reference: MAStringDescription new;
		beOrdered;
		beRequired;
		beDistinct;
		yourself! !

!RLWidget class methodsFor: 'testing' stamp: 'pmm 5/29/2006 16:36'!
isAbstract
	^false! !

!RLWidget class methodsFor: 'testing' stamp: 'pmm 5/29/2006 16:36'!
label
	^ 'Google Related Links'! !

!RLWidget class methodsFor: 'accessing' stamp: 'pmm 5/29/2006 20:08'!
types
	^#('Searches' 'News' 'Web Pages')! !

!RLWidget methodsFor: 'accessing' stamp: 'pmm 5/29/2006 20:04'!
colors
	^colors! !

!RLWidget methodsFor: 'accessing' stamp: 'pmm 5/29/2006 20:04'!
colors: anObject
	colors := anObject! !

!RLWidget methodsFor: 'accessing' stamp: 'pmm 5/29/2006 20:03'!
format
	^format! !

!RLWidget methodsFor: 'accessing' stamp: 'pmm 5/29/2006 20:03'!
format: anObject
	format := anObject! !

!RLWidget methodsFor: 'testing' stamp: 'pmm 6/1/2006 18:51'!
isVisible
	^super isVisible
		and: [ self format notNil ]
		and: [ self colors notNil ]
		and: [ self type notNil ]! !

!RLWidget methodsFor: 'rendering' stamp: 'pmm 6/1/2006 20:07'!
javascriptDictionary
	| dictionary |
	^String streamContents: [ :stream |
		stream nextPutAll: 'var google_rc = '.
		dictionary := Dictionary new.
		dictionary at: 'modules' put: self type.
		dictionary addAll: self format properties.
		dictionary addAll: self colors properties.
		dictionary javascriptOn: stream.
		stream nextPut: $; ]! !

!RLWidget methodsFor: 'rendering' stamp: 'pmm 8/26/2006 00:06'!
renderWidgetOn: html
	html script: self javascriptDictionary.
	html script
		url: 'http://relcontent.googlesyndication.com/relcontent/show_rc.js';
		with: '' "stupid fucking seaside"! !

!RLWidget methodsFor: 'accessing' stamp: 'pmm 5/29/2006 20:03'!
type
	^type! !

!RLWidget methodsFor: 'accessing' stamp: 'pmm 5/29/2006 20:03'!
type: anObject
	type := anObject! !

!MAStringReader methodsFor: '*RelatedLinks' stamp: 'pmm 6/1/2006 19:11'!
visitPropertyDescription: aDescription
	self shouldNotImplement! !

!MAStringWriter methodsFor: '*RelatedLinks' stamp: 'pmm 6/1/2006 19:13'!
visitPropertyDescription: aDescription
	self stream nextPutAll: self object name! !

MAElementDescription subclass: #RLPropertyDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RelatedLinks'!

!RLPropertyDescription class methodsFor: 'testing' stamp: 'pmm 6/1/2006 19:14'!
isAbstract
	^false! !

!RLPropertyDescription methodsFor: 'visiting' stamp: 'pmm 6/1/2006 19:58'!
acceptMagritte: aVisitor
	aVisitor visitPropertyDescription: self! !

!RLPropertyDescription methodsFor: 'accessing' stamp: 'pmm 6/1/2006 19:10'!
kind
	^ RLPropertyObject! !
